<?php

declare(strict_types=1);

namespace KupShop\CatalogBundle\Entity\Product;

use KupShop\KupShopBundle\Util\Price\Price;
use KupShop\KupShopBundle\Util\Price\ProductPrice;

class ProductPricesResult
{
    public function __construct(
        protected ProductPrice $price, // Prodejní cena
        protected ?Price $originalPrice, // Cena před slevou
        protected ?Price $retailPrice, // Doporučená maloobchodní cena
        protected \Decimal $discount, // Aktuálně zobrazovaná sleva
        protected \Decimal $retailPriceDiscount, // Sleva prodejní vůči maloobchodní ceně
    ) {
    }

    public function getOriginalPrice(): ?Price
    {
        return $this->originalPrice;
    }

    public function getRetailPrice(): ?Price
    {
        return $this->retailPrice;
    }

    public function getDiscount(): \Decimal
    {
        return $this->discount;
    }

    public function getPrice(): ProductPrice
    {
        return $this->price;
    }

    public function getRetailPriceDiscount(): \Decimal
    {
        return $this->retailPriceDiscount;
    }
}
